<!--开学季活动-->
<template>
	<div class="newterm-alert" id="newtermAlert">
		<div class="newterm-content">
			<div class="alert1 inactive">
				<div class="close"></div>
				<div class="btn"></div>
			</div>
			<div class="alert2 inactive">
				<div class="close"></div>
				<div class="btn"></div>
			</div>
		</div>
	</div>
	<div class="newterm-banner" id="newtermBanner">
		<div class="banner1 inactive">
			<div class="btn">
				<img class="btn-img newterm-heartbeat" src="http://static2.61info.com/service/imgs/groupPurchase/act/newTerm2020/btn_go1.png" alt="">
			</div>
		</div>
		<div class="banner2 inactive">
			<div class="btn">
				<img class="btn-img newterm-heartbeat" src="http://static2.61info.com/service/imgs/groupPurchase/act/newTerm2020/btn_go1.png" alt="">
			</div>
		</div>
	</div>
	<div class="newterm-float" id="newtermFloat">
		<img class="float1 inactive newterm-float-tada" src="http://static2.61info.com/service/imgs/groupPurchase/act/newTerm2020/entry_float1.png" alt="">
		<div class="float2 inactive"></div>
	</div>
</template>

<script>
	export default {
		name: 'newTerm2020',
		data: {
			pageName: $('body').data('page-name'),
			actUrl: '/app/spa/dengta_h5/newTerm2020',
			showMouseBanner: false,
			channelMap: {
				MOUSE_ALERT: 142200001,
				FREE_ALERT: 142200002,
				'moreCourse': {
					MOUSE_BANNER: 142200036,
					FREE_BANNER: 142200035,
					MOUSE_FLOAT: 142200014,
					FREE_FLOAT: 142200018,
				},
				'courseList': {
					MOUSE_BANNER: 142200009,
					FREE_BANNER: 142200010,
					MOUSE_FLOAT: 142200013,
					FREE_FLOAT: 142200017
				}
			},
			recordClExposures: []
		},
		// 初始化
		init: function () {
			var _this = this;
			request.entry({}, function (res) {
				if (res.resultCode.code == 0) {
					var resData = res.value;
					if (!(resData.sys > resData.start && resData.sys < resData.end)) {
						return
					}
					var beginLongTime = resData.sys - resData.start;
					_this.data.showMouseBanner = beginLongTime > 24 * 60 * 60 * 1000 && beginLongTime < 3 * 24 * 60 * 60 * 1000;

					$('body').on('newTerm2020', function (e, callback) {
						if (_this.data.pageName == 'moreCourse') {
							_this.initAlert(callback);
						}
						_this.initEntry();
					})
				}
			})
		},
		// 入口
		initEntry: function () {
			var _this = this;

			// banner
			var $banner = $(newtermBanner);
			var activeBannerElem = '.' + (_this.data.showMouseBanner ? 'banner2' : 'banner1');
			if (_this.data.pageName == 'moreCourse') {
				$banner.css({margin: '.4rem 0 0 -.3rem'})
			}
			$banner.find(activeBannerElem).show();
			var $beforeDom = _this.data.pageName == 'moreCourse' && $('.course_box_classic').eq(0).hasClass('module_item_8') ? $('.course_box_classic').get(1) : $('.course_box_classic').get(0);
			$banner.insertAfter($beforeDom);

			// float
			var $float = $(newtermFloat);
			var activeFloatElem = '.' + (_this.data.showMouseBanner ? 'float2' : 'float1');
			$float.find(activeFloatElem).show();
			if (!_this.data.showMouseBanner) {
				$float.css('overflow', 'visible')
			}
			$('body').append($float);

			$banner.on('click', function () {
				_this.toAct('BANNER');
			})
			$float.on('click', function () {
				_this.toAct('FLOAT');
			})

			_this.initScroll($banner, $float);
		},
		initScroll: function ($banner, $float) {
			var _this = this;
			if (utils.isInView($banner.get(0))) {
				_this.addPvuv('BANNER');
				$float.hide();
			} else {
				_this.addPvuv('FLOAT');
			}
			document.addEventListener('scroll', utils.throttle(function () {
				if (utils.isInView($banner.get(0))) {
					_this.addPvuv('BANNER');
					$float.hide();
				} else {
					_this.addPvuv('FLOAT');
					$float.show();
				}
			}, 300))
		},
		initAlert: function (callback) {
			var _this = this;
			var storageName = 'newTermAlert' + (_this.data.showMouseBanner ? 'alert2' : 'alert1');
			if (localStorage.getItem(storageName)) {
				return
			}
			localStorage.setItem(storageName, storageName);

			$alert = $(newtermAlert);
			var activeAlertElem = '.' + (_this.data.showMouseBanner ? 'alert2' : 'alert1');
			$alert.find(activeAlertElem).show();
			$('body').append($alert);
			$alert.on('click', '.close', function () {
				$alert.hide();
			})
			$alert.on('click', '.btn', function () {
				_this.toAct('ALERT');
			})
			_this.addPvuv('ALERT');
			callback && callback();
		},
		toAct: function (type) {
			var _this = this;
			var channel = _this.getChannel(type);
			location.href = _this.data.actUrl + '?channel=' + channel;
		},
		// 统计曝光，根据渠道
		addPvuv: function (type) {
			var _this = this;
			var channel = _this.getChannel(type);
			if (_this.data.recordClExposures.indexOf(channel) >= 0) {
				return
			}
			request.addChannels(1174, channel, function () {
				_this.data.recordClExposures.push(channel)
			})
		},
		getChannel: function (type) {
			var _this = this;
			var channelMap = _this.data.channelMap;
			var perfixType = _this.data.showMouseBanner ? 'MOUSE_' : 'FREE_'
			var channel = '';
			switch (type) {
				case 'ALERT':
					channel = channelMap[perfixType + type];
					break
				default:
					channel = channelMap[_this.data.pageName][perfixType + type];
					break
			}
			return channel;
		}
	}
</script>

<style scoped lang="less">
	@BASE_IMG_URL: 'http://static2.61info.com/service/imgs/groupPurchase/act/newTerm2020';

	.active {
		display: block;
	}
	.inactive {
		display: none;
	}

	.newterm-alert {
		position: fixed;
		top: 0;
		left: 0;
		z-index: 1100;
		background: rgba(0, 0, 0, .85);
		width: 100%;
		height: 100%;
		.newterm-content {
			position: absolute;
			top: 50%;
			left: 50%;
			transform: translate(-50%, -50%);
			.alert1 {
				width: 593px;
				height: 790px;
				background: url('@{BASE_IMG_URL}/entry_alert1.png') no-repeat center / 100%;
				.close {
					width: 100px;
					height: 52px;
					position: absolute;
					top: 0;
					right: 0;
				}
				.btn {
					position: absolute;
					left: 50%;
					bottom: 51px;
					transform: translateX(-50%);
					width: 292px;
					height: 81px;
				}
			}
			.alert2 {
				width: 750px;
				height: 891px;
				background: url('@{BASE_IMG_URL}/entry_alert2.png') no-repeat center / 100%;
				.close {
					width: 52px;
					height: 52px;
					position: absolute;
					bottom: 0;
					left: 50%;
					transform: translateX(-50%);
				}
				.btn {
					position: absolute;
					left: 50%;
					bottom: 151px;
					transform: translateX(-50%);
					width: 475px;
					height: 150px;
				}
			}
		}
	}
	.newterm-banner {
		width: 750px;
		margin: 0 0 80px -18px;
		.banner1 {
			margin: 0 auto;
			position: relative;
			width: 742px;
			height: 212px;
			background: url('@{BASE_IMG_URL}/entry_banner1.png') no-repeat center / 100%;
			.btn {
				position: absolute;
				right: 0;
				bottom: 18px;
				width: 146px;
				height: 154px;
			}
		}
		.banner2 {
			margin: 0 auto;
			position: relative;
			width: 694px;
			height: 181px;
			background: url('@{BASE_IMG_URL}/entry_banner2.png') no-repeat center / 100%;
			.btn {
				position: absolute;
				right: 15px;
				bottom: 11px;
				width: 115px;
				height: 123px;
			}
		}
	}
	.newterm-float {
		position: fixed;
		left: 10px;
		bottom: 20%;
		overflow: hidden;
		.float1 {
			width: 147px;
			height: 159px;
		}
		.float2 {
			width: 120px;
			height: 120px;
			background-size: 100% 100%;
			background-repeat: no-repeat;
			background-position: center center;
			animation: floatAnimate 4s infinite;
			@keyframes floatAnimate {
				0% {
					transform: translateX(-100%);
				}
				0%, 49% {
					/*background: url('@{BASE_IMG_URL}/entry_float2_1.png') no-repeat center / 100%;*/
					background-image: url('@{BASE_IMG_URL}/entry_float2_1.png');
				}
				49% {
					transform: translateX(0);
				}
				50% {
					transform: translateX(-100%);
				}
				50%, 99% {
					/*background: url('@{BASE_IMG_URL}/entry_float2_2.png') no-repeat center / 100%;*/
					background-image: url('@{BASE_IMG_URL}/entry_float2_2.png');
				}
				99% {
					transform: translateX(0);
				}
			}
		}
	}

	/*animate*/
	.newterm-heartbeat {
		animation: heartBeat 1s infinite;
	}
	.newterm-float-tada {
		animation: tada 1s infinite;
	}
	@keyframes tada {
		from {
			-webkit-transform: scale3d(0.8, 0.8, 0.8);
			transform: scale3d(0.8, 0.8, 0.8);
		}

		10%,
		20% {
			-webkit-transform: scale3d(0.7, 0.7, 0.7) rotate3d(0, 0, 1, -3deg);
			transform: scale3d(0.7, 0.7, 0.7) rotate3d(0, 0, 1, -3deg);
		}

		30%,
		50%,
		70%,
		90% {
			-webkit-transform: scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, 3deg);
			transform: scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, 3deg);
		}

		40%,
		60%,
		80% {
			-webkit-transform: scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg);
			transform: scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg);
		}

		to {
			-webkit-transform: scale3d(0.8, 0.8, 0.8);
			transform: scale3d(0.8, 0.8, 0.8);
		}
	}
	@-webkit-keyframes heartBeat {
		0% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}

		14% {
			-webkit-transform: scale(.8);
			transform: scale(.8);
		}

		28% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}

		42% {
			-webkit-transform: scale(.8);
			transform: scale(.8);
		}

		70% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}
	}
</style>
